"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var CacheModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.CacheModule = void 0;
const common_1 = require("@nestjs/common");
const cache_constants_1 = require("./cache.constants");
const redis_1 = require("redis");
let CacheModule = CacheModule_1 = class CacheModule {
    static register(cacheModuleOption) {
        cacheModuleOption = {
            ...this.defaultCacheModuleOptions,
            ...cacheModuleOption,
        };
        this.instanceCacheModuleOptions = cacheModuleOption;
        return {
            global: cacheModuleOption.isGlobal ?? false,
            module: CacheModule_1,
            providers: [
                {
                    provide: cache_constants_1.REDIS_SERVICE,
                    useFactory: async () => await (0, redis_1.createClient)(cacheModuleOption)
                        .on('error', (err) => {
                        throw new Error(err);
                    })
                        .connect(),
                },
            ],
            exports: [cache_constants_1.REDIS_SERVICE],
        };
    }
    static registerAsync(cacheModuleAsyncOption) {
        const providers = [
            {
                provide: cache_constants_1.REDIS_SERVICE,
                useFactory: async (...args) => {
                    const options = {
                        ...this.defaultCacheModuleOptions,
                        ...(await cacheModuleAsyncOption.useFactory?.(...args)),
                    };
                    this.instanceCacheModuleOptions = options;
                    const client = (0, redis_1.createClient)(options);
                    await client
                        .on('error', (err) => {
                        throw new Error(err);
                    })
                        .connect();
                    return client;
                },
                inject: cacheModuleAsyncOption.injects || [],
            },
        ];
        if (cacheModuleAsyncOption.extraProviders)
            providers.push(...cacheModuleAsyncOption.extraProviders);
        return {
            global: cacheModuleAsyncOption.isGlobal ?? false,
            module: CacheModule_1,
            imports: cacheModuleAsyncOption.imports || [],
            providers,
            exports: [cache_constants_1.REDIS_SERVICE],
        };
    }
    static getInstance() {
        return this.instanceCacheModuleOptions;
    }
};
exports.CacheModule = CacheModule;
CacheModule.defaultCacheModuleOptions = {
    url: 'redis://localhost:6379',
    LFU: { ttl: 60, max: 100 },
    LRU: { ttl: 60, max: 100 },
    FIFO: { ttl: 60, max: 100 },
};
exports.CacheModule = CacheModule = CacheModule_1 = __decorate([
    (0, common_1.Module)({})
], CacheModule);
//# sourceMappingURL=cache.module.js.map